package com.mortals.xhx.module.notice.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.YesNoEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.notice.model.NoticeEntity;
import com.mortals.xhx.module.notice.service.NoticeService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;

import java.util.Arrays;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 用户消息
 *
 * @author zxfei
 * @date 2023-04-15
 */
@RestController
@RequestMapping("notice")
public class NoticeController extends BaseCRUDJsonBodyMappingController<NoticeService, NoticeEntity, Long> {

    @Autowired
    private ParamService paramService;

    public NoticeController() {
        super.setModuleDesc("用户消息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "read", YesNoEnum.getEnumMap());
        super.init(model, context);
    }

    @Override
    protected void doListBefore(NoticeEntity query, Map<String, Object> model, Context context) throws AppException {
        query.setUserId(this.getContextUserId(context));
        query.setOrderField("read");
        query.setOrderKind(OrderCol.DESCENDING);
        super.doListBefore(query, model, context);
    }


    @Override
    protected int viewAfter(Long id, Map<String, Object> model, NoticeEntity entity, Context context) throws AppException {
        NoticeEntity noticeEntity = this.service.get(id, getContext());
        noticeEntity.setRead(YesNoEnum.YES.getValue());
        this.service.update(noticeEntity, getContext());

        return super.viewAfter(id, model, entity, context);
    }
}